当前位置: 首页 > 工具软件 > Mouse Trap > 使用案例 >

【并查集 基环树】 Educational Codeforces Round 49 (Rated for Div. 2) D. Mouse Hunt

欧阳洲
2023-12-01

D. Mouse Hunt

time limit per test   2 seconds               memory limit per test    256 megabytes

Medicine faculty of Berland State University has just finished their admission campaign. As usual, about 80%80% of applicants are girls and majority of them are going to live in the university dormitory for the next 44 (hopefully) years.

The dormitory consists of nn rooms and a single mouse! Girls decided to set mouse traps in some rooms to get rid of the horrible monster. Setting a trap in room number ii costs cici burles. Rooms are numbered from 11 to nn.

Mouse doesn't sit in place all the time, it constantly runs. If it is in room ii in second tt then it will run to room aiai in second t+1t+1 without visiting any other rooms inbetween (i=aii=ai means that mouse won't leave room ii). It's second 00 in the start. If the mouse is in some room with a mouse trap in it, then the mouse get caught into this trap.

That would have been so easy if the girls actually knew where the mouse at. Unfortunately, that's not the case, mouse can be in any room from 11 to nn at second 00.

What it the minimal total amount of burles girls can spend to set the traps in order to guarantee that the mouse will eventually be caught no matter the room it started from?

Input

The first line contains as single integers n (1≤n≤2⋅10^5) — the number of rooms in the dormitory.

The second line contains nn integers c1,c2,…,cnc1,c2,…,cn (1≤ci≤10^4) — cici is the cost of setting the trap in room number i.

The third line contains nn integers a1,a2,…,ana1,a2,…,an (1≤ai≤n) — aiai is the room the mouse will run to the next second after being in room i.

Output

Print a single integer — the minimal total amount of burles girls can spend to set the traps in order to guarantee that the mouse will eventually be caught no matter the room it started from.

Examples

input

5
1 2 3 2 10
1 3 4 3 3

output

3

input

4
1 10 2 10
2 4 2 2

output

10

input

7
1 1 1 1 1 1 1
2 2 2 3 6 7 6

output

2

Note

In the first example it is enough to set mouse trap in rooms 1 and 4. If mouse starts in room 1 then it gets caught immideately. If mouse starts in any other room then it eventually comes to room 4.

In the second example it is enough to set mouse trap in room 2. If mouse starts in room 2 then it gets caught immideately. If mouse starts in any other room then it runs to room 2 in second 1.

Here are the paths of the mouse from different starts from the third example:

  • 1→2→2→…;
  • 2→2→…;
  • 3→2→2→…;
  • 4→3→2→2→…;
  • 5→6→7→6→…;
  • 6→7→6→…;
  • 7→6→7→…;

So it's enough to set traps in rooms 2 and 6.

 

给你n个点,每个点放捕鼠器的价钱,老鼠从每个点出发到达的下一个点
问怎样防止捕鼠器可以一定捕到老鼠且花费最少
这个就是一个基环树,每一个点出度为1

基环树,也是环套树,简单地讲就是树上再加一条边。
它形如一个环,环上每个点都有一棵子树的形式。因此,对基环树的处理大部分就是对树处理和对环处理。
其实结果就是所有的单独点价值,和环中最小价值之和
可以直接用并查集做

#include <bits/stdc++.h>
using namespace std;
const int maxn=2e5+5;
int cost[maxn],pre[maxn],fa[maxn];

int find(int x)
{
    if(pre[x]==x) return x;
    return pre[x]=find(pre[x]);
}

int main()
{
    int n;
    while(~scanf("%d",&n))
    {
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&cost[i]);
            pre[i]=i,fa[i]=i;
        }
        for(int i=1;i<=n;i++)
        {
            int temp;
            scanf("%d",&temp);
            fa[i]=temp;
            int fx=find(i),fy=find(temp);
            if(fx!=fy) pre[fx]=fy; //要是两个节点父亲不同,代表他们不是一个环
            else  //要是父亲相同,就代表已经成环,那么在环中找到最小价值的数额
            {
                int minn=cost[fx];
                while(temp!=fx)
                {
                    minn=min(minn,cost[temp]);
                    temp=fa[temp];
                }
                cost[fx]=minn; //给父亲节点赋最小价值,因为最后答案都是加父亲节点的
            }
        }
        for(int i=1;i<=n;i++) find(i); //保险起见,在进行一次路径压缩
        int sum=0;
        for(int i=1;i<=n;i++)
        {
            if(i==pre[i]) sum+=cost[i];
        }
        printf("%d\n",sum);
    }
    return 0;
}

 

 类似资料: